var grab = null;

// Main menu
function Menu ()
{
  if (!scene)
  {
    var menu = DefaultMapMenu (12, 40, 110, GetScreenHeight() - 40);
        
    menu.addText("Status", function() {
      StatsMenu ();
    });

    menu.addText("Inventory", function() {
      InventoryMenu ();
    });

    menu.addText("Close", function() {
      menu.done = true;
    });
    
    menu.addText("Exit Game", function() {
      Exit ();
    });
    
    
    menu.postRender = function() {

    }

    menu.execute ();
  }
}

// Status
function StatsMenu ()
{
  var menu = DefaultMapMenu (30, 40, 110, GetScreenHeight() - 40);
               
  var player_indexes = []; 
  for (var i = 0; i < Player.length; i++) { 
   if (Player[i].used) 
     player_indexes.push(i); 
  }
  
  var who = player_indexes[0];
  
  for (i = 0; i < player_indexes.length; i++)
  {      
    if (Player[i].used == true)
    {
      menu.addText(Player[i].name, function() {
        var player = player_indexes[menu.selection]; 
        who = player_indexes[player];   
      });
    }
  }
  
  menu.addText("Close", function() {
    menu.done = true;
  });
    
  menu.postRender = function() {
  	sys.window.drawWindow (120,40,175,142); 
	  if (menu.selection < player_indexes.length)
		{
	   	sys.font.drawText (125, 42,  "Name: "      + Player[who].name);
			sys.font.drawText (125, 52,  "HP: "        + Player[who].hp + "/" + Player[who].maxhp);
			sys.font.drawText (125, 62,  "MP: "        + Player[who].mp + "/" + Player[who].maxmp);
			sys.font.drawText (125, 72,  "Strength: "  + Player[who].str);
			sys.font.drawText (125, 82,  "Agility: "   + Player[who].agi);
			sys.font.drawText (125, 92,  "Charisma: "  + Player[who].cha);
			sys.font.drawText (125, 102, "Type: "      + Player[who].typ);
    
			sys.font.drawText (125, 122, "Armor: "     + Armor[Player[who].armor].name);
			sys.font.drawText (125, 132, "Weapon: "    + Weapon[Player[who].weapon].name);
			sys.font.drawText (125, 142, "Accessory: " + Accessory[Player[who].accessory].name);
    }
  }
  
  menu.execute ();
}

// Inventory
function InventoryMenu ()
{
  var menu = DefaultMapMenu (100, 40, 110, GetScreenHeight() - 40);

  menu.addText("Items", function() {
    ItemsMenu ();
  });
  
  menu.addText("Armor", function() {
    ArmorMenu (); 
  });
  
  menu.addText("Weapon", function() {
    WeaponsMenu ();
  });
  
  menu.addText("Accessories", function() {
    AccessoryMenu ();
  });
  
  menu.addText("Close", function() {
    menu.done = true;
  });
  
  menu.execute ();
}


// Item menu
function ItemsMenu ()
{
  var menu = DefaultMapMenu (170, 40, 130, GetScreenHeight() - 40);
  var selected_item;

  var item_indexes = []; 
  for (var i = 0; i < Items.length; i++) { 
    if (Items[i].amount > 0) item_indexes.push(i); 
  }
  
  for (i = 0; i < item_indexes.length; i++)
  {      
    if (Items[item_indexes[i]].amount > 0)
    {
      selected_item = Items[item_indexes[i]].name;
      menu.addText(Items[item_indexes[i]].name + " x" + Items[item_indexes[i]].amount, function() {
        UseItem (Items[item_indexes[menu.selection]]); 
        menu.done = true;	 
      });
    }
  }
  
  menu.addText("Close", function() {
    menu.done = true;
  });
  
  menu.postRender = function() {
    sys.window.drawWindow (30,180,GetScreenWidth()-60,40);   
    if (menu.selection < item_indexes.length)    
      sys.font.drawTextBox(32, 182, GetScreenWidth() - 62, 38, 0, Items[item_indexes[menu.selection]].name + ": " + Items[item_indexes[menu.selection]].description);  
  }
  
  menu.execute ();
}

// To use items
function UseItem (which)
{
  var menu = DefaultMapMenu (30, 40, 110, GetScreenHeight() - 40);
               
  var player_indexes = []; 
  for (var i = 0; i < Player.length; i++) { 
   if (Player[i].used) 
     player_indexes.push(i); 
  }
    
  for (i = 0; i < player_indexes.length; i++)
  {      
    if (Player[i].used == true)
    {
      menu.addText(Player[i].name, function() {
        var who = player_indexes[menu.selection];
      
        switch (which.name)
        {
					case "Potion":
					{
						if (Player[who].hp < Player[who].maxhp)
						{
						  Player[who].hp += 50;
						  Items[0].amount --;	  					  
					  }
					  else
					  {
					    // Make an uh-uh sound
					  }
					  
					  if (Player[who].hp > Player[who].maxhp)
					    Player[who].hp = Player[who].maxhp;	
					  if (Items[0].amount == 0)
					  {
					    ItemsMenu ();	
					    menu.done = true;	    
						}
						break;
					}
    
					case "Ether":
					{					
						if (Player[who].mp < Player[who].maxmp)
						{
						  Player[who].mp += 50;
						  Items[1].amount --;
					  }
					  else
					  {
					    // Make an uh-uh sound
					  } 
					  
					  if (Player [who].mp > Player[who].maxmp)
					    Player[who].mp = Player[who].maxmp;				
					  if (Items[1].amount == 0)
					  {
					    ItemsMenu ();	
					    menu.done = true;	    
						}
						break;
					}
    
					case "Large Potion":
					{
						if (Player[who].hp < Player[who].maxhp)
						{
						  Player[who].hp += 100;
						  Items[2].amount --;
					  }
					  else
					  {
					    // Make an uh-uh sound
					  }
					  
					  if (Player [who].hp > Player[who].maxhp)
					    Player[who].hp = Player[who].maxhp;	
					  if (Items[2].amount == 0)
					  {
					    ItemsMenu ();	
					    menu.done = true;	    
						}						break;
					}
					 
					default:
					{
						Abort ("Inventory has an error somewhere!");
						break;
					}    
				}
      });
    }
  }
  
  menu.addText("Close", function() {
    menu.done = true;
		ItemsMenu ();
  });
    
  menu.postRender = function() {
    sys.window.drawWindow (120, 205, 175, 20);
		sys.font.drawText (125, 208, which.name + " x" + which.amount);
  
    if (menu.selection < player_indexes.length)  
    {
			sys.window.drawWindow (120,40,175,142); 
			sys.font.drawText (125, 42,  "Name: "      + Player[player_indexes[menu.selection]].name);
			sys.font.drawText (125, 52,  "HP: "        + Player[player_indexes[menu.selection]].hp + "/" + Player[player_indexes[menu.selection]].maxhp);
			sys.font.drawText (125, 62,  "MP: "        + Player[player_indexes[menu.selection]].mp + "/" + Player[player_indexes[menu.selection]].maxmp);
			sys.font.drawText (125, 72,  "Strength: "  + Player[player_indexes[menu.selection]].str);
			sys.font.drawText (125, 82,  "Agility: "   + Player[player_indexes[menu.selection]].agi);
			sys.font.drawText (125, 92,  "Charisma: "  + Player[player_indexes[menu.selection]].cha);
			sys.font.drawText (125, 102, "Type: "      + Player[player_indexes[menu.selection]].typ);
			
			sys.font.drawText (125, 122, "Armor: "     + Armor[Player[player_indexes[menu.selection]].armor].name);
			sys.font.drawText (125, 132, "Weapon: "    + Weapon[Player[player_indexes[menu.selection]].weapon].name);
			sys.font.drawText (125, 142, "Accessory: " + Accessory[Player[player_indexes[menu.selection]].accessory].name);
		}
  }
  
  menu.execute ();
}

// Armor menu
function ArmorMenu ()
{
  var menu = DefaultMapMenu (150, 40, 160, GetScreenHeight() - 40);
  var selected_item;

  var armor_indexes = []; 
  for (var i = 0; i < Armor.length; i++) { 
    if (Armor[i].amount > 0) armor_indexes.push(i); 
  }
  
  for (i = 0; i < armor_indexes.length; i++)
  {      
    if (Armor[armor_indexes[i]].amount > 0)
    {
      selected_item = Armor[armor_indexes[i]].name;
      menu.addText(Armor[armor_indexes[i]].name + " x" + Armor[armor_indexes[i]].amount, function() {
        EquipArmor (armor_indexes[menu.selection]);
        menu.done = true;
      });
    }
  }
  
  menu.addText("Close", function() {
    menu.done = true;
  });
  
  menu.postRender = function() {
    sys.window.drawWindow (30,180,GetScreenWidth()-60,40);   
    if (menu.selection < armor_indexes.length)    
      sys.font.drawTextBox(32, 182, GetScreenWidth() - 62, 38, 0, Armor[armor_indexes[menu.selection]].name + ": " + Armor[armor_indexes[menu.selection]].description);  
  }
  
  menu.execute ();
}

// To equip the armor
function EquipArmor (which)
{
  var menu = DefaultMapMenu (30, 40, 110, GetScreenHeight() - 40);
  var player_indexes = []; 
  
  for (var i = 0; i < Player.length; i++) { 
   if (Player[i].used) 
     player_indexes.push(i); 
  }
    
  for (i = 0; i < player_indexes.length; i++)
  {      
    if (Player[i].used)
    {
      menu.addText(Player[i].name, function() {
          Armor[Player[menu.selection].armor].amount ++;
          Armor[which].amount --;
          Player[menu.selection].armor = which;
      });
    }
  }
  
  menu.addText("Close", function() {  
  
    menu.done = true;
    ArmorMenu ();
  });
  
  menu.postRender = function() { 
    if (menu.selection < player_indexes.length)  
    {
			sys.window.drawWindow (120,40,175,142); 
			sys.font.drawText (125, 42,  "Name: "      + Player[player_indexes[menu.selection]].name);
			sys.font.drawText (125, 52,  "HP: "        + Player[player_indexes[menu.selection]].hp + "/" + Player[player_indexes[menu.selection]].maxhp);
			sys.font.drawText (125, 62,  "MP: "        + Player[player_indexes[menu.selection]].mp + "/" + Player[player_indexes[menu.selection]].maxmp);
			sys.font.drawText (125, 72,  "Strength: "  + Player[player_indexes[menu.selection]].str);
			sys.font.drawText (125, 82,  "Agility: "   + Player[player_indexes[menu.selection]].agi);
			sys.font.drawText (125, 92,  "Charisma: "  + Player[player_indexes[menu.selection]].cha);
			sys.font.drawText (125, 102, "Type: "      + Player[player_indexes[menu.selection]].typ);
			
			sys.font.drawText (125, 122, "Armor: "     + Armor[Player[player_indexes[menu.selection]].armor].name);
			sys.font.drawText (125, 132, "Weapon: "    + Weapon[Player[player_indexes[menu.selection]].weapon].name);
			sys.font.drawText (125, 142, "Accessory: " + Accessory[Player[player_indexes[menu.selection]].accessory].name);
 		}
  }
  
  menu.execute ();
}

// Weapons menu
function WeaponsMenu ()
{
  var menu = DefaultMapMenu (150, 40, 160, GetScreenHeight() - 40);
  var selected_item;

  var weapons_indexes = []; 
  for (var i = 0; i < Weapon.length; i++) { 
    if (Weapon[i].amount > 0) weapons_indexes.push(i); 
  }
  
  for (i = 0; i < weapons_indexes.length; i++)
  {      
    if (Weapon[weapons_indexes[i]].amount > 0)
    {
      selected_item = Weapon[weapons_indexes[i]].name;
      menu.addText(Weapon[weapons_indexes[i]].name + " x" + Weapon[weapons_indexes[i]].amount, function() {
        EquipWeapon (weapons_indexes[menu.selection]);
        menu.done = true;
      });
    }
  }
  
  menu.addText("Close", function() {
    menu.done = true;
  });
  
  menu.postRender = function() {
    sys.window.drawWindow (30,180,GetScreenWidth()-60,40);   
    if (menu.selection < weapons_indexes.length)    
      sys.font.drawTextBox(32, 182, GetScreenWidth() - 62, 38, 0, Weapon[weapons_indexes[menu.selection]].name + ": " + Weapon[weapons_indexes[menu.selection]].description);  
  }
  
  menu.execute ();
}

// To equip the weapon
function EquipWeapon (which)
{
  var menu = DefaultMapMenu (30, 40, 110, GetScreenHeight() - 40);
  var player_indexes = []; 
  
  for (var i = 0; i < Player.length; i++) { 
   if (Player[i].used) 
     player_indexes.push(i); 
  }
    
  for (i = 0; i < player_indexes.length; i++)
  {      
    if (Player[i].used)
    {
      menu.addText(Player[i].name, function() {
          Weapon[Player[menu.selection].weapon].amount ++;
          Weapon[which].amount --;
          Player[menu.selection].weapon = which;
      });
    }
  }
  
  menu.addText("Close", function() {  
  
    menu.done = true;
    WeaponsMenu ();
  });
  
  menu.postRender = function() {
    if (menu.selection < player_indexes.length)  
    {
			sys.window.drawWindow (120,40,175,142); 
			sys.font.drawText (125, 42,  "Name: "      + Player[player_indexes[menu.selection]].name);
			sys.font.drawText (125, 52,  "HP: "        + Player[player_indexes[menu.selection]].hp + "/" + Player[player_indexes[menu.selection]].maxhp);
			sys.font.drawText (125, 62,  "MP: "        + Player[player_indexes[menu.selection]].mp + "/" + Player[player_indexes[menu.selection]].maxmp);
			sys.font.drawText (125, 72,  "Strength: "  + Player[player_indexes[menu.selection]].str);
			sys.font.drawText (125, 82,  "Agility: "   + Player[player_indexes[menu.selection]].agi);
			sys.font.drawText (125, 92,  "Charisma: "  + Player[player_indexes[menu.selection]].cha);
			sys.font.drawText (125, 102, "Type: "      + Player[player_indexes[menu.selection]].typ);
			
			sys.font.drawText (125, 122, "Armor: "     + Armor[Player[player_indexes[menu.selection]].armor].name);
			sys.font.drawText (125, 132, "Weapon: "    + Weapon[Player[player_indexes[menu.selection]].weapon].name);
			sys.font.drawText (125, 142, "Accessory: " + Accessory[Player[player_indexes[menu.selection]].accessory].name);
 		}
  }
  
  menu.execute ();
}

// Accessory menu
function AccessoryMenu ()
{
  var menu = DefaultMapMenu (150, 40, 160, GetScreenHeight() - 40);
  var selected_item;

  var accessory_indexes = []; 
  for (var i = 0; i < Accessory.length; i++) { 
    if (Accessory[i].amount > 0) accessory_indexes.push(i); 
  }
  
  for (i = 0; i < accessory_indexes.length; i++)
  {      
    if (Accessory[accessory_indexes[i]].amount > 0)
    {
      selected_item = Accessory[accessory_indexes[i]].name;
      menu.addText(Accessory[accessory_indexes[i]].name + " x" + Accessory[accessory_indexes[i]].amount, function() {
        EquipAccessory (accessory_indexes[menu.selection]);
        menu.done = true;
      });
    }
  }
  
  menu.addText("Close", function() {
    menu.done = true;
  });
  
  menu.postRender = function() {
    sys.window.drawWindow (30,180,GetScreenWidth()-60,40);   
    if (menu.selection < accessory_indexes.length)    
      sys.font.drawTextBox(32, 182, GetScreenWidth() - 62, 38, 0, Accessory[accessory_indexes[menu.selection]].name + ": " + Accessory[accessory_indexes[menu.selection]].description);  
  }
  
  menu.execute ();
}

// To equip the accessory
function EquipAccessory (which)
{
  var menu = DefaultMapMenu (30, 40, 110, GetScreenHeight() - 40);
  var player_indexes = []; 
  
  for (var i = 0; i < Player.length; i++) { 
   if (Player[i].used) 
     player_indexes.push(i); 
  }
    
  for (i = 0; i < player_indexes.length; i++)
  {      
    if (Player[i].used)
    {
      menu.addText(Player[i].name, function() {
          Accessory[Player[menu.selection].accessory].amount ++;
          Accessory[which].amount --;
          Player[menu.selection].accessory = which;
      });
    }
  }
  
  menu.addText("Close", function() {  
  
    menu.done = true;
    AccessoryMenu ();
  });
  
  menu.postRender = function() {
    if (menu.selection < player_indexes.length)  
    {
			sys.window.drawWindow (120,40,175,142); 
			sys.font.drawText (125, 42,  "Name: "      + Player[player_indexes[menu.selection]].name);
			sys.font.drawText (125, 52,  "HP: "        + Player[player_indexes[menu.selection]].hp + "/" + Player[player_indexes[menu.selection]].maxhp);
			sys.font.drawText (125, 62,  "MP: "        + Player[player_indexes[menu.selection]].mp + "/" + Player[player_indexes[menu.selection]].maxmp);
			sys.font.drawText (125, 72,  "Strength: "  + Player[player_indexes[menu.selection]].str);
			sys.font.drawText (125, 82,  "Agility: "   + Player[player_indexes[menu.selection]].agi);
			sys.font.drawText (125, 92,  "Charisma: "  + Player[player_indexes[menu.selection]].cha);
			sys.font.drawText (125, 102, "Type: "      + Player[player_indexes[menu.selection]].typ);
			
			sys.font.drawText (125, 122, "Armor: "     + Armor[Player[player_indexes[menu.selection]].armor].name);
			sys.font.drawText (125, 132, "Weapon: "    + Weapon[Player[player_indexes[menu.selection]].weapon].name);
			sys.font.drawText (125, 142, "Accessory: " + Accessory[Player[player_indexes[menu.selection]].accessory].name);
 		}
  }
  
  menu.execute ();
}



