// movement.js

// ////////////////////////////////////////// //
//           RPG 0.05 by Wild-Tiger           //
// ////////////////////////////////////////// //

var walking = true;

// Names for the movement!
var Face_North		  = COMMAND_FACE_NORTH; 
var Move_North		  = COMMAND_MOVE_NORTH;

var Face_South		  = COMMAND_FACE_SOUTH; 
var Move_South		  = COMMAND_MOVE_SOUTH;

var Face_East 			= COMMAND_FACE_EAST; 
var Move_East       = COMMAND_MOVE_EAST;

var Face_West       = COMMAND_FACE_WEST; 
var Move_West       = COMMAND_MOVE_WEST;

var Face_South_West = COMMAND_FACE_SOUTHWEST;
var Face_North_West = COMMAND_FACE_NORTHWEST;

var Face_South_East = COMMAND_FACE_SOUTHEAST;
var Face_North_East = COMMAND_FACE_NORTHEAST;

// Face character in a direction
function Face (name, face)
{
  QueuePersonScript("hidden", "QueuePersonCommand (\""+name+"\", "+face+", false);", false); 
}

function Face2 (name, face)
{
  QueuePersonCommand (name, face, false);
}

function Wait (times)
{
  for (i = 0; i < times; i++) 
    QueuePersonScript("hidden", "QueuePersonCommand ('hidden', COMMAND_WAIT, false);", false); 
}

// Causes NPC to face player when you speak to them.
function Face_Player (name)
{
  switch (GetPersonDirection("Player"))
  {
    case "north":{
      SetPersonDirection (name, "south"); 
      break;
    }
    case "south":{
      SetPersonDirection (name, "north");
      break;
    }
    case "east":{
      SetPersonDirection (name, "west");
      break;
    }
    case "west":{
      SetPersonDirection (name, "east");
      break;
    }
    case "northeast":{
      SetPersonDirection (name, "southwest");
      break;
    }
    case "southeast":{
      SetPersonDirection (name, "northwest");
      break;
    }
    case "northwest":{
      SetPersonDirection (name, "southeast");
      break;
    }
    case "southwest":{
      SetPersonDirection (name, "northeast");
      break;
    }
    default: {
      Abort ("Error in movement script");
    }
  } 
  return true;
}

// Moves a character in a direction, facing a direction several times.
function Move (name, times, move, face){
  if (face == undefined)
  {
    switch (move)
    {
      case (Move_North):
      {
        face = Face_North;
        break;
      }
      case (Move_South):
      {
        face = Face_South;
        break;
      }
      case (Move_East):
      {
        face = Face_East;
        break;
      }
      case (Move_West):
      {
        face = Face_West;
        break;
      }   
    }
  }
  
  for (j = 0; j < times; j++)
  {
    QueuePersonScript("hidden", "QueuePersonCommand ('" + name + "', "  + face + ", false);", false); 
    for (i = 0; i < 16; i++)
    {
      QueuePersonScript("hidden", "QueuePersonCommand ('" + name + "', "  + move + ", false);", false); 
    }
  }
}

// Used for making NPCs and such move at the SAME time.
function Move2(name, times, move,  face)
{
  if (face == undefined)
  {
    switch (move)
    {
      case (Move_North):
      {
        face = Face_North;
        break;
      }
      case (Move_South):
      {
        face = Face_South;
        break;
      }
      case (Move_East):
      {
        face = Face_East;
        break;
      }
      case (Move_West):
      {
        face = Face_West;
        break;
      }   
    }
  }

  for (j = 0; j < times; j++)
  {
    QueuePersonCommand (name, face, false); 
    for (i = 0; i < 16; i++)
    {
      QueuePersonCommand (name, move, false); 
    }
  }
}

function DisablePlayerMovement ()
{
  QueuePersonScript("hidden", "DetachInput  ('Player'); DetachCamera ('Player');", false);
}

function EnablePlayerMovement ()
{
 QueuePersonScript("hidden", "AttachInput  ('Player'); AttachCamera ('Player');", false);
}

function StopMovement ()
{
  QueuePersonScript("hidden", "walking = false;", false); 
}

function StartMovement ()
{
  QueuePersonScript("hidden", "walking = true", false);
}

// Stolen from...Fenix, I think..? :) Thanks -whoever- made it.
// Makes an NPC walk randomly.
function Walk_Random (name, waitLength, stepLength){
  if (walking)
  {
    if (!waitLength)
      waitLength = 0;
    if (!stepLength)
      stepLength = 1;
    var random = Math.floor(Math.random()*5);
    var action;
    switch (random){
      case (0): action = COMMAND_WAIT; break;
      case (1): action = COMMAND_MOVE_NORTH; break;
      case (2): action = COMMAND_MOVE_EAST; break;
      case (3): action = COMMAND_MOVE_SOUTH; break;
      case (4): action = COMMAND_MOVE_WEST; break;
    }
    switch (action){
      case (COMMAND_WAIT):
        for (var i = 0; i < 16; i++){
          for (var j = 0; j < stepLength; j++){
            QueuePersonCommand (name, action, false);
          }
          for (var j = 0; j < waitLength; j++){
            QueuePersonCommand (name, COMMAND_WAIT, false);
          }
        }
        break;
      case (COMMAND_MOVE_NORTH):
        QueuePersonCommand (name, COMMAND_FACE_NORTH, true);
        for (var i = 0; i < 16; i++){
          for (var j = 0; j < stepLength; j++){
            QueuePersonCommand (name, action, false);
          }
          for(var j = 0; j < waitLength; j++){
            QueuePersonCommand (name, COMMAND_WAIT, false);
          }
        }
        break;
      case (COMMAND_MOVE_EAST):
        QueuePersonCommand (name, COMMAND_FACE_EAST, true);
        for (var i = 0; i < 16; i++){
          for (var j = 0; j < stepLength; j++){
            QueuePersonCommand (name, action, false);
          }
          for (var j = 0; j < waitLength; j++){
            QueuePersonCommand (name, COMMAND_WAIT, false);
          }
        }
        break;
      case (COMMAND_MOVE_SOUTH):
        QueuePersonCommand (name, COMMAND_FACE_SOUTH, true);
        for (var i = 0; i < 16; i++){
          for (var j = 0; j < stepLength; j++){
            QueuePersonCommand (name, action, false);
          }
          for (var j = 0; j < waitLength; j++){
            QueuePersonCommand (name, COMMAND_WAIT, false);
          }
        }
        break;
      case (COMMAND_MOVE_WEST):
        QueuePersonCommand (name, COMMAND_FACE_WEST, true);
        for (var i = 0; i < 16; i++){
          for (var j = 0; j < stepLength; j++){
            QueuePersonCommand (name, action, false);
          }
          for (var j = 0; j < waitLength; j++){
            QueuePersonCommand (name, COMMAND_WAIT, false);
          }
        }
      break;
    }
  }
}
